#include <atlcomcli.h>
#include <strsafe.h>

#include "Rot.h"


HRESULT CRot::AddToRot(IUnknown *pUnkGraph, DWORD * pdwRegister)
{
		IMoniker * pMoniker = NULL;
		IRunningObjectTable *pROT = NULL;

		if (FAILED(GetRunningObjectTable(0, &pROT))) 
		{
			return E_FAIL;
		}

		const size_t STRING_LENGTH = 256;

		WCHAR wsz[STRING_LENGTH];

		StringCchPrintfW(wsz, STRING_LENGTH, L"FilterGraph %08x pid %08x", (DWORD_PTR)pUnkGraph, GetCurrentProcessId());

		HRESULT hr = CreateItemMoniker(L"!", wsz, &pMoniker);
		if (SUCCEEDED(hr)) 
		{
			hr = pROT->Register(ROTFLAGS_REGISTRATIONKEEPSALIVE, 
				                pUnkGraph,
				                pMoniker, 
								pdwRegister);
			pMoniker->Release();
		}
		pROT->Release();

		return hr;
}

void CRot::RemoveGraph(DWORD pdwRegister)
{
		IRunningObjectTable *pROT;
		if (SUCCEEDED(GetRunningObjectTable(0, &pROT))) 
		{
			pROT->Revoke(pdwRegister);
			pROT->Release();
		}
}    